
#include "sssd.h"
#include "internals.h"

/*
    Pauses audio output until unpauseAudio() is called.

    This may safely be called mulitple times.
    While audio is paused calls to playSample and playBackground are ignored.
    stopSample, stopBackground, and checkBackground work as expected.

    Do not call loadSample or copySample when audio is paused.
*/

void sssd_pauseAudio( struct sssdaudio* ga )
{
    if( audioValid( ga ) && ga->paused == 0 )
    {
        LOCK_BUFFERS(ga);
        ga->paused = 1;
    }
}

