#ifndef __LIBSSSD_H__
#define __LIBSSSD_H__

/*!
    @function symbian_usleep
    
    @discussion
        Suspends the current thread for the specified number of microseconds. 
        Assumes a 32-bit int specifying the duration - which thus is a range of 
        +/-2147483647 microseconds (i.e. +/- 35min, 47sec).
 */
void symbian_usleep(int microseconds);

void MutexWait(void *mutex);
void MutexSignal(void *mutex);
void MutexClose(void *mutex);

#endif /* __LIBSSSD_H__ */