/* The code in this file is public domain  */
/* Author: Patrick Roberts */


/* Load a simple WAV format audio file - to replace loadSample removed
     from libsssd in libsssd demos.
     
*/

#ifndef _LOADSIMPLEWAVE_H
#define _LOADSIMPLEWAVE_H

/* quick hack - assumes 32-bit CPU) */

typedef struct waveFile {
  
  unsigned int RIFF_dsize; /* this gets overwritten with the data size */
  int          filesize;
  unsigned int WAVE;

  unsigned int chunkID;   /* this is overwritten with the number of samples */
  unsigned int chunkSize;
  
  unsigned short format;
  unsigned short channels;
  unsigned int   freq;
  unsigned int   byps;
  unsigned short align;
  unsigned short bits;
  
  void          *PCMdata;
  
} waveFile;


#define simpleWave2copySample(a,b,c) sssd_copySampleStereo(a,b->PCMdata,b->channels,b->freq,b->bits,b->chunkSize,COPY_STEREO|c)

#ifdef __SYMBIAN32__
waveFile * loadSimpleWave(char *filename);
#else
#ifdef _WIN32_WCE
waveFile * loadSimpleWave(char *filename);
#else
#include "loadSimpleWave.c"
#endif
#endif

#endif /* _LOADSIMPLEWAVE_H */
